#property copyright "Copyright  2008, Group Three LLC"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 LightCoral
#property indicator_color5 Green
#property indicator_color6 Red

extern int KPeriod = 14;
extern int DPeriod = 3;
extern int Slowing = 5;
extern int ShrtEMAPeriod = 13;
extern int LongEMAPeriod = 21;
int gi_unused_96 = 0;
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
double gd_124;
double g_icustom_132;
double g_icustom_140;
double g_icustom_148;
double g_icustom_156;
double g_icustom_164;
double g_icustom_172;
double g_icustom_180;
double g_icustom_188;
double g_icustom_196;
double g_icustom_204;
double gd_220;

int init() {
   double ld_4;
   double ld_12;
   int li_20;
   if (IsDllsAllowed() == FALSE) {
      Alert("Allow for DLL calls in the \'properties-->common\' popup window");
      ld_4 = 0;
      ld_12 = 1 / ld_4;
      return (0);
   } 
   SetIndexStyle(0, DRAW_ARROW, EMPTY, 1);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 1);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexStyle(4, DRAW_ARROW, EMPTY, 1);
   SetIndexStyle(5, DRAW_ARROW, EMPTY, 1);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);
   SetIndexEmptyValue(4, 0.0);
   SetIndexEmptyValue(5, 0.0);
   SetIndexArrow(0, 116);
   SetIndexArrow(1, 116);
   SetIndexArrow(4, SYMBOL_STOPSIGN);
   SetIndexArrow(5, SYMBOL_STOPSIGN);
   SetIndexArrow(6, 116);
   IndicatorDigits(Digits);
   SetIndexDrawBegin(0, 9);
   SetIndexDrawBegin(1, 9);
   SetIndexDrawBegin(2, 9);
   SetIndexDrawBegin(3, 9);
   SetIndexDrawBegin(4, 9);
   SetIndexDrawBegin(5, 9);
   IndicatorBuffers(6);
   SetIndexBuffer(0, g_ibuf_100);
   SetIndexBuffer(1, g_ibuf_104);
   SetIndexBuffer(2, g_ibuf_108);
   SetIndexBuffer(3, g_ibuf_112);
   SetIndexBuffer(4, g_ibuf_116);
   SetIndexBuffer(5, g_ibuf_120);
   SetIndexLabel(0, "Buy");
   SetIndexLabel(1, "Sell");
   SetIndexLabel(2, "Stop Long");
   SetIndexLabel(3, "Stop Short");
   SetIndexLabel(4, "Stop Long");
   SetIndexLabel(5, "Stop Short");
   int li_0 = 100;
   if (Period() <= 10) li_0 = 15;
   if (Period() == PERIOD_M15) li_0 = 20;
   if (Period() == PERIOD_M30) li_0 = 38;
   if (Period() == PERIOD_H1) li_0 = 62;
   if (Period() == PERIOD_H4) li_0 = 100;
   if (Period() >= PERIOD_D1) li_0 = 138;
   gd_220 = li_0 * Point;
   return (0);
}

int deinit() {
   ObjectsDeleteAll();
   Comment(" ");
   return (0);
}

void IsLicenseValid() {
   int li_8;
   int li_0 = 0;
   int li_4 = 0;
   if (li_4 == -1) Comment("Connecting to the server...");
   if (li_4 == 1) {
      Comment("Invalid License. Please contact Quantum");
      li_8 = 1 / li_0;
   }
}

int start() {
   double ld_24;
   double ld_32;
   double l_icustom_40;
   double l_icustom_48;
   double ld_56;
   double ld_64;
   double l_icustom_72;
   double l_icustom_80;
   bool l_bool_88;
   bool l_bool_92;
   bool l_bool_96;
   bool l_bool_100;
   bool l_bool_104;
   bool l_bool_108;
   bool l_bool_128;
   bool l_bool_132;
   int li_4 = IndicatorCounted();
   IsLicenseValid();
   gd_124 = Ask - Bid;
   double ld_8 = 5.0 * Point;
   double ld_16 = ld_8;
   if (li_4 < 0) return (-1);
   if (li_4 > 0) li_4--;
   int li_0 = Bars - li_4;
   for (int li_136 = li_0; li_136 >= 0; li_136--) {
      QuantumFFL(li_136);
      l_icustom_72 = iCustom(NULL, 0, "QuantumStoch", KPeriod, DPeriod, Slowing, 0, li_136);
      l_icustom_80 = iCustom(NULL, 0, "QuantumStoch", KPeriod, DPeriod, Slowing, 1, li_136);
      l_icustom_40 = iCustom(NULL, 0, "QuantumHEMA", ShrtEMAPeriod, 2, li_136 + 1);
      ld_56 = iCustom(NULL, 0, "QuantumHEMA", ShrtEMAPeriod, 2, li_136) - l_icustom_40;
      l_icustom_48 = iCustom(NULL, 0, "QuantumHEMA", LongEMAPeriod, 2, li_136 + 1);
      ld_64 = iCustom(NULL, 0, "QuantumHEMA", LongEMAPeriod, 2, li_136) - l_icustom_48;
      l_bool_104 = ld_56 > 0.0 && ld_64 > 0.0 && l_icustom_72 > l_icustom_80;
      l_bool_88 = g_icustom_132 < g_icustom_164 && Open[li_136] > g_icustom_180 && Open[li_136] > g_icustom_188 && l_bool_104;
      l_bool_96 = g_icustom_132 > g_icustom_148 && g_icustom_132 > g_icustom_140 && Open[li_136] + ld_16 > g_icustom_148 && l_bool_104;
      l_bool_128 = g_icustom_172 == 0.0 && l_bool_88 || l_bool_96;
      g_ibuf_100[li_136] = l_bool_128 * Open[li_136];
      l_bool_108 = ld_56 < 0.0 && ld_64 < 0.0 && l_icustom_72 < l_icustom_80;
      l_bool_92 = g_icustom_132 > g_icustom_156 && Open[li_136] < g_icustom_180 && Open[li_136] < g_icustom_188 && l_bool_108;
      l_bool_100 = g_icustom_132 < g_icustom_148 && g_icustom_132 < g_icustom_140 && Open[li_136] - ld_8 < g_icustom_148 && l_bool_108;
      l_bool_132 = g_icustom_172 == 0.0 && l_bool_92 || l_bool_100;
      g_ibuf_104[li_136] = l_bool_132 * Open[li_136];
      ld_24 = Open[li_136] - gd_220;
      ld_32 = Open[li_136] + gd_220 + gd_124;
      g_ibuf_108[li_136] = ld_24;
      g_ibuf_112[li_136] = ld_32;
      g_ibuf_116[li_136] = l_bool_128 * ld_24;
      g_ibuf_120[li_136] = l_bool_132 * ld_32;
   }
   return (0);
}

void QuantumFFL(int ai_0) {
   g_icustom_132 = iCustom(NULL, 0, "QuantumFilter", 0, ai_0);
   g_icustom_140 = iCustom(NULL, 0, "QuantumFilter", 0, ai_0 + 1);
   g_icustom_148 = iCustom(NULL, 0, "QuantumFilter", 1, ai_0);
   g_icustom_156 = iCustom(NULL, 0, "QuantumFilter", 2, ai_0);
   g_icustom_164 = iCustom(NULL, 0, "QuantumFilter", 3, ai_0);
   g_icustom_172 = iCustom(NULL, 0, "QuantumFilter", 5, ai_0);
   g_icustom_180 = iCustom(NULL, 0, "QuantumFilter", 6, ai_0);
   g_icustom_188 = iCustom(NULL, 0, "QuantumFilter", 7, ai_0);
   g_icustom_196 = iCustom(NULL, 0, "QuantumFilterOsc", 0, ai_0);
   g_icustom_204 = iCustom(NULL, 0, "QuantumFilterOsc", 0, ai_0 + 1);
}